︠f40ffb4d-8f0e-4712-bdff-80e905a687d5s︠
# Kaip papildyti vektorių sistemą iki erdvės bazės?

def papildom_poerdviai(W, V):
    """
    Gražina tiesinės erdvės V poerdvio W papildinio iki V bazę. 
    Kitaip sakant, randa tokį poerdvį U, kad V yra W ir U tiesioginė 
    suma ir gražina jo bazę.
    """
    Q, pi, lift = V.quotient_abstract(W)
    Basis = [lift(v) for v in Q.basis()]
    return Basis

# pi   yra projekcijos atvaizdis iš erdvės V į faktorerdvę V/W: pi(v) = v + W.
# lift yra "atvirkštinis" atvaizdis iš faktorerdvės Q = V/W  į  erdvę V, tenkinantis 
# lygybę pi(lift(u)) = u  su visais u iš Q.


def papildom(vec, V):
    """
    Tiesinės erdvės V vektorių šeimą vec papildo vektoriais v1,..., vn iki 
    erdvės V bazės ir gražina papildytus vektorius v1,..., vn.
    """
    return papildom_poerdviai(V.span(vec), V)

︡8be550ab-8d1f-49b7-aaa9-493cc7a5167e︡{"done":true}
︠59876658-4e86-4924-b8cb-1a7385dfc614s︠
# Pavyzdžiui,
vec = [vector([1,0,0]),vector([1,1,0])]
papildom(vec, QQ^3)

︡7ca8fc49-f4f6-42b5-a18d-23746c4921ba︡{"stdout":"[(0, 0, 1)]\n"}︡{"done":true}
︠44f2fe55-9290-413d-b25c-d1c130e79e8cs︠
A = matrix(QQ, 8, 8, [[-39,14,18,-6,-14,5,-2,-1],
                      [-83,31,33,-12,-25,10,-4,-1],
                      [-61,18,29,-10,-20,8,0,-3],
                      [18,-9,-8,4,6,-1,5,-2],
                      [-61,18,26,-10,-17,8,0,-3],
                      [-38,10,23,-6,-20,8,1,-5],
                      [1,0,-2,0,2,0,3,1],
                      [72,-23,-28,11,21,-9,2,5]])
show(A)
︡2d25ed67-68f8-4df7-8cde-afd379a4ffc3︡{"html":"<div align='center'>$\\displaystyle \\left(\\begin{array}{rrrrrrrr}\n-39 &amp; 14 &amp; 18 &amp; -6 &amp; -14 &amp; 5 &amp; -2 &amp; -1 \\\\\n-83 &amp; 31 &amp; 33 &amp; -12 &amp; -25 &amp; 10 &amp; -4 &amp; -1 \\\\\n-61 &amp; 18 &amp; 29 &amp; -10 &amp; -20 &amp; 8 &amp; 0 &amp; -3 \\\\\n18 &amp; -9 &amp; -8 &amp; 4 &amp; 6 &amp; -1 &amp; 5 &amp; -2 \\\\\n-61 &amp; 18 &amp; 26 &amp; -10 &amp; -17 &amp; 8 &amp; 0 &amp; -3 \\\\\n-38 &amp; 10 &amp; 23 &amp; -6 &amp; -20 &amp; 8 &amp; 1 &amp; -5 \\\\\n1 &amp; 0 &amp; -2 &amp; 0 &amp; 2 &amp; 0 &amp; 3 &amp; 1 \\\\\n72 &amp; -23 &amp; -28 &amp; 11 &amp; 21 &amp; -9 &amp; 2 &amp; 5\n\\end{array}\\right)$</div>"}︡{"done":true}
︠441cb7b2-a5e5-4b9d-b2b3-a8ec4ee2a0b0︠
︡d1cd2702-2559-4bdb-9717-fde5028f3a01︡
︠4df37f34-40fa-4386-8d3e-acf546497e8f︠
# 2 pavyzdys. Rasime matricos
show(A)
︡06620453-bfcb-48e6-8978-d61509ff0e45︡{"html":"<div align='center'>$\\displaystyle \\left(\\begin{array}{rrrrrrrr}\n-39 &amp; 14 &amp; 18 &amp; -6 &amp; -14 &amp; 5 &amp; -2 &amp; -1 \\\\\n-83 &amp; 31 &amp; 33 &amp; -12 &amp; -25 &amp; 10 &amp; -4 &amp; -1 \\\\\n-61 &amp; 18 &amp; 29 &amp; -10 &amp; -20 &amp; 8 &amp; 0 &amp; -3 \\\\\n18 &amp; -9 &amp; -8 &amp; 4 &amp; 6 &amp; -1 &amp; 5 &amp; -2 \\\\\n-61 &amp; 18 &amp; 26 &amp; -10 &amp; -17 &amp; 8 &amp; 0 &amp; -3 \\\\\n-38 &amp; 10 &amp; 23 &amp; -6 &amp; -20 &amp; 8 &amp; 1 &amp; -5 \\\\\n1 &amp; 0 &amp; -2 &amp; 0 &amp; 2 &amp; 0 &amp; 3 &amp; 1 \\\\\n72 &amp; -23 &amp; -28 &amp; 11 &amp; 21 &amp; -9 &amp; 2 &amp; 5\n\\end{array}\\right)$</div>"}︡{"done":true}
︠fb199b02-96ef-43e4-a2cc-9ae3167ce57d︠
# Žodano formą ir atitinkamą bazę.
︡63ca029e-ba8a-43d7-8e02-4fab12cc094f︡
︠8555027e-5823-4784-8596-081a5d57f26bi︠
%md 
Sprendimas
︡c17382eb-1570-49fa-a1f7-ae32bc254e73︡{"md":"Sprendimas\n"}︡
︠8a97b92a-a29e-4f6b-bc6a-e43341fe7f31s︠
# Randame matricos charakteristinį polinomą:

p = A.charpoly(var = 't')
show(p.factor())
︡330d1923-b37f-4f0c-9f48-9d442e867bec︡{"html":"<div align='center'>$\\displaystyle (t - 3)^{8}$</div>"}︡{"done":true}
︠55f5051b-c9a1-4efa-b320-0a4286c07211s︠
# Nagrinėjame matricą B := A-3*E ir skaičiuojame jos laipsnių branduolių dimensijas:
B = A - 3*matrix.identity(8)
show(B)
︡b82d2537-44c4-419a-8e65-c3ac853a3211︡{"html":"<div align='center'>$\\displaystyle \\left(\\begin{array}{rrrrrrrr}\n-42 &amp; 14 &amp; 18 &amp; -6 &amp; -14 &amp; 5 &amp; -2 &amp; -1 \\\\\n-83 &amp; 28 &amp; 33 &amp; -12 &amp; -25 &amp; 10 &amp; -4 &amp; -1 \\\\\n-61 &amp; 18 &amp; 26 &amp; -10 &amp; -20 &amp; 8 &amp; 0 &amp; -3 \\\\\n18 &amp; -9 &amp; -8 &amp; 1 &amp; 6 &amp; -1 &amp; 5 &amp; -2 \\\\\n-61 &amp; 18 &amp; 26 &amp; -10 &amp; -20 &amp; 8 &amp; 0 &amp; -3 \\\\\n-38 &amp; 10 &amp; 23 &amp; -6 &amp; -20 &amp; 5 &amp; 1 &amp; -5 \\\\\n1 &amp; 0 &amp; -2 &amp; 0 &amp; 2 &amp; 0 &amp; 0 &amp; 1 \\\\\n72 &amp; -23 &amp; -28 &amp; 11 &amp; 21 &amp; -9 &amp; 2 &amp; 2\n\\end{array}\\right)$</div>"}︡{"done":true}
︠f839f5d1-0e63-45b5-a8e8-c687626af9d3s︠
# Matricos B branduolys ker B ir jo dimensija:
L1 = B.left_kernel()
L1.dimension()
︡fec064e6-63a4-44bd-b71a-b9085301f4f8︡{"stdout":"3\n"}︡{"done":true}
︠561a0d81-5b90-4a8e-a9d8-548373343eads︠
# Matricos B^2 branduolys ker B^2 ir jo dimensija:
L2 = (B**2).left_kernel()
L2.dimension()
︡ddb56538-94d6-491a-800b-5ca00c2e9c17︡{"stdout":"6\n"}︡{"done":true}
︠a6c1524a-addb-4e13-bc9a-005565cc8c1ds︠
# Matricos B^3 branduolys ker B^3 ir jo dimensija:
L3 = (B**3).left_kernel()
L3.dimension()
︡a18207ff-021d-41b5-bad2-4197a1f4a77f︡{"stdout":"7\n"}︡{"done":true}
︠0faf202c-b0da-43e2-ba4d-04683bbc4a34s︠
# Matricos B^4 branduolys ker B^4 ir jo dimensija:
L4 = (B**4).left_kernel()
L4.dimension()
︡97c6f0d9-1529-494c-a9f8-211377ec048a︡{"stdout":"8\n"}︡{"done":true}
︠e003613d-1849-4d3c-bd59-3935719e3888s︠
# Poerdvio L3 bazę pildant iki erdvės L4 bazės, reikia pridėti 1 vektorių, kurį 
# atitiks lygiai vianas 4-os eilės Žordano langelis.
# Rasime šį vektorių:

v1 = papildom(L3.basis(), L4)[0]
v1
︡267a4e2d-27f6-4b80-be62-1c8828d70d36︡{"stdout":"(1, 0, 0, 0, 0, 0, 0, 0)\n"}︡{"done":true}
︠37f72aa0-d152-4557-b9a3-8bccf955e21cs︠
# Suskaičiuojame dar tris vektorius:

v2 = v1*B  # priklauso L3
v3 = v2*B  # priklauso L2
v4 = v3*B  # priklauso L1
v2
v3
v4
︡bfb4102e-6d56-4427-b875-9417d80ef1e9︡{"stdout":"(-42, 14, 18, -6, -14, 5, -2, -1)\n"}︡{"stdout":"(-14, 3, 5, -3, -3, 2, 1, -1)\n"}︡{"stdout":"(16, -6, -5, 2, 4, -2, 1, 0)\n"}︡{"done":true}
︠76fd8c47-ef88-4806-b386-f1a4a0411617s︠
# Vektorius v1, v2, v3 ir v4 atitinka lygiai vianas 4-os eilės Žordano langelis. 

# Poerdvio L2 bazę pildant iki erdvės L3 bazės, reikia pridėti 1 vektorių.
# Tačiau poerdvyje L3 jau turime vektorių v2, kuris nepriklauso L2. Todėl
# 3-os eilės Žordano langelių nebus.

# Poerdvio L1 bazę pildant iki erdvės L2 bazės, reikia pridėti 6-3=3 vektorius.
# Vieną vektorių jau turime: vektorius v3 priklauso L2, bet nepriklauso L1.
# Taigi vektorių šeimą {v3, L1 bazė} pildant iki L2 bazės, reikės pridėti 
# lygiai 2 vektorius. Kiekvieną iš šių vektorių atitiks 2-os eilės Žordano 
# langelis. Rasime šiuos vektorius:

vektoriai = papildom(L1.basis()+[v3], L2)
v5 = vektoriai[0]
v7 = vektoriai[1]
v5
v7
︡5c33ca89-2722-4bd1-9b8a-6ece6564f304︡{"stdout":"(1, 0, 0, 0, 0, 0, 1/2, 1/2)\n"}︡{"stdout":"(0, 1, 0, 0, 0, 0, 0, 1)\n"}︡{"done":true}
︠74bdb1a7-d3aa-4ec7-be3a-77a6dc7b6c31s︠
# Suskaičiuojame dar du vektorius:

v6 = v5*B  # priklauso L1
v8 = v7*B  # priklauso L1
v6
v8
︡b29cb55a-0764-46c2-b14f-77405e467783︡{"stdout":"(-11/2, 5/2, 3, -1/2, -5/2, 1/2, -1, 1/2)\n"}︡{"stdout":"(-11, 5, 5, -1, -4, 1, -2, 1)\n"}︡{"done":true}
︠87cc1a4b-5fb3-4a30-a49d-d659995df9a4s︠
# Vektorius v5, v6 atitinka vienas 2-os eilės Žordano langelis, o 
# vektorius v7, v8 -- dar vienas 2-os eilės Žordano langelis.

# Taigi radome Žordano bazę v1,v2,...,v8. 
# Perėjimo matrica (iš standartinės bazės į Žordano bazę):

T = matrix(QQ,8,8,[v1,v2,v3,v4,v5,v6,v7,v8])
show(T)
︡67cb4b38-ff8a-44f7-9751-e3a7791957d7︡{"html":"<div align='center'>$\\displaystyle \\left(\\begin{array}{rrrrrrrr}\n1 &amp; 0 &amp; 0 &amp; 0 &amp; 0 &amp; 0 &amp; 0 &amp; 0 \\\\\n-42 &amp; 14 &amp; 18 &amp; -6 &amp; -14 &amp; 5 &amp; -2 &amp; -1 \\\\\n-14 &amp; 3 &amp; 5 &amp; -3 &amp; -3 &amp; 2 &amp; 1 &amp; -1 \\\\\n16 &amp; -6 &amp; -5 &amp; 2 &amp; 4 &amp; -2 &amp; 1 &amp; 0 \\\\\n1 &amp; 0 &amp; 0 &amp; 0 &amp; 0 &amp; 0 &amp; \\frac{1}{2} &amp; \\frac{1}{2} \\\\\n-\\frac{11}{2} &amp; \\frac{5}{2} &amp; 3 &amp; -\\frac{1}{2} &amp; -\\frac{5}{2} &amp; \\frac{1}{2} &amp; -1 &amp; \\frac{1}{2} \\\\\n0 &amp; 1 &amp; 0 &amp; 0 &amp; 0 &amp; 0 &amp; 0 &amp; 1 \\\\\n-11 &amp; 5 &amp; 5 &amp; -1 &amp; -4 &amp; 1 &amp; -2 &amp; 1\n\\end{array}\\right)$</div>"}︡{"done":true}
︠71220edc-2b06-4d68-b5b2-9ff06067ba9as︠
# Pradinės matricos Žordano matrica:

show(T*A*(T^(-1)))
︡b40b6ec7-ef34-4d91-96b3-5d64a4795ba2︡{"html":"<div align='center'>$\\displaystyle \\left(\\begin{array}{rrrrrrrr}\n3 &amp; 1 &amp; 0 &amp; 0 &amp; 0 &amp; 0 &amp; 0 &amp; 0 \\\\\n0 &amp; 3 &amp; 1 &amp; 0 &amp; 0 &amp; 0 &amp; 0 &amp; 0 \\\\\n0 &amp; 0 &amp; 3 &amp; 1 &amp; 0 &amp; 0 &amp; 0 &amp; 0 \\\\\n0 &amp; 0 &amp; 0 &amp; 3 &amp; 0 &amp; 0 &amp; 0 &amp; 0 \\\\\n0 &amp; 0 &amp; 0 &amp; 0 &amp; 3 &amp; 1 &amp; 0 &amp; 0 \\\\\n0 &amp; 0 &amp; 0 &amp; 0 &amp; 0 &amp; 3 &amp; 0 &amp; 0 \\\\\n0 &amp; 0 &amp; 0 &amp; 0 &amp; 0 &amp; 0 &amp; 3 &amp; 1 \\\\\n0 &amp; 0 &amp; 0 &amp; 0 &amp; 0 &amp; 0 &amp; 0 &amp; 3\n\\end{array}\\right)$</div>"}︡{"done":true}
︠f7694100-1a48-4cf5-94f8-46e0080c88a4i︠
%md
\[
\left(\begin{array}{rrrrrrrr}
\color{red}{3} & \color{red}{1} & \color{red}{0} & \color{red}{0} & 0 & 0 & 0 & 0 \\
\color{red}{0} & \color{red}{3} & \color{red}{1} & \color{red}{0} & 0 & 0 & 0 & 0 \\
\color{red}{0} & \color{red}{0} & \color{red}{3} & \color{red}{1} & 0 & 0 & 0 & 0 \\
\color{red}{0} & \color{red}{0} & \color{red}{0} & \color{red}{3} & 0 & 0 & 0 & 0 \\
0 & 0 & 0 & 0 & \color{blue}{3} & \color{blue}{1} & 0 & 0 \\
0 & 0 & 0 & 0 & \color{blue}{0} & \color{blue}{3} & 0 & 0 \\
0 & 0 & 0 & 0 & 0 & 0 & \color{blue}{3} & \color{blue}{1} \\
0 & 0 & 0 & 0 & 0 & 0 & \color{blue}{0} & \color{blue}{3}
\end{array}\right)
\]
︡fd69c806-4019-4628-8062-0221ba210357︡{"md":"\\[\n\\left(\\begin{array}{rrrrrrrr}\n\\color{red}{3} & \\color{red}{1} & \\color{red}{0} & \\color{red}{0} & 0 & 0 & 0 & 0 \\\\\n\\color{red}{0} & \\color{red}{3} & \\color{red}{1} & \\color{red}{0} & 0 & 0 & 0 & 0 \\\\\n\\color{red}{0} & \\color{red}{0} & \\color{red}{3} & \\color{red}{1} & 0 & 0 & 0 & 0 \\\\\n\\color{red}{0} & \\color{red}{0} & \\color{red}{0} & \\color{red}{3} & 0 & 0 & 0 & 0 \\\\\n0 & 0 & 0 & 0 & \\color{blue}{3} & \\color{blue}{1} & 0 & 0 \\\\\n0 & 0 & 0 & 0 & \\color{blue}{0} & \\color{blue}{3} & 0 & 0 \\\\\n0 & 0 & 0 & 0 & 0 & 0 & \\color{blue}{3} & \\color{blue}{1} \\\\\n0 & 0 & 0 & 0 & 0 & 0 & \\color{blue}{0} & \\color{blue}{3}\n\\end{array}\\right)\n\\]\n"}︡
︠70fe8e34-35b6-49b7-b3f1-3ed48754ca02︠


T.columns?









